#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>

#pragma GCC optimize("03")

using namespace std;

vector<vector<int>>g;
vector <int>used;
set<int>res;

void dfs(int pos1, int stam) {
	used[pos1] = 1;

	if (stam == 0) { return; }
	
	for (auto pos2 : g[pos1]) {
		dfs(pos2, stam - 1);
	}
}


void solve() {
	int n, m, k;
	cin >> n >> m >> k;

	g.resize(n, vector<int>{});
	used.resize(n, 0);

	int pos1, pos2;
	for (int i = 0; i < m; i++) {
		cin >> pos1 >> pos2;
		g[pos1 - 1].push_back(pos2 - 1);
		g[pos2 - 1].push_back(pos1 - 1);
	}

	int off, stam;
	for (int i = 0; i < k; i++) {
		cin >> off >> stam;
		dfs(off - 1, stam);
	}

	cout << used.size() << '\n';

	if (used.size()) {
		for (int i = 0; i < n; i++) {
			if (used[i]) {
				cout << i + 1 << ' ';
			}
		}
	}
}

int main() {
	cin.tie(0);
	cout.tie(0);
	int t = 1;
	// cin >> t;

	for (int i = 0; i < t; i++) {
		solve();
	}
	return 0;
}